# <a href="https://gitlab.com/fortunalab/publications/phenotypic-plasticity-of-an-evolving-digital-organism/blob/master/The%20phenotypic%20plasticity%20of%20an%20evolving%20digital%20organism.pdf" target="_blank">The phenotypic plasticity of an evolving digital organism.</a>

## 1. Data set and R code used in this study:

### Overview:
- data_overview.ipynb (as a jupyter notebook)

### Working data:
- File_S1.csv (467 MB)
> input data used to perform the statistical analysis of this paper.
- File_S2.csv (53 MB)
> input data used to explain the trade-off between fitness cost and phenotypic plasticity.

### Jupyter Notebooks:
- File_S2.ipynb
> Probability for an organism to encode plastic phenotypes explained by the sensitiviy of the genome to changes in transcription.
- File_S3.ipynb
> Number of phenotypes explained by the sensitivity of the genome to changes in transcription.
- File_S4.ipynb
> Phenotypic uncertainty explained by the sensitivity of a genome to changes in transcription.
- File_S5.ipynb
> Probability for an organism to be viable explained by the phenotypic plasticity.
- File_S6.ipynb
> Number of phenotypes explained by the number of transcriptomes and the cost of transcription.
- File_S7.ipynb 
> Transcriptome length explained by the phenotypic plasticity and the sensitivity of the genome to changes in transcription.
- File_S8.ipynb 
> Number of input-output instructions executed explained by the sensitivity of the genome to changes in transcription.

### R scripts (counterparts of the above jupyter notebooks):
- File_S2.R
- File_S3.R
- File_S4.R
- File_S5.R
- File_S6.R
- File_S7.R
- File_S8.R

---
## 2. Configuration files and bash scripts used in this study (folder *database*):

### <a href="https://github.com/devosoft/avida" target="_blank">Avida version 2.14.0</a> 

#### Configuration files required to run Avida:
- avida.cfg
> We use the Avida default file and modify some configuration options directly from the command line when executing Avida in analyze mode (see the bash script *get_database.sh*).
- events.cfg
> It must exist, but will not be used when running Avida in analyze mode (empty file).
- environment.cfg
> No selective pressure exists towards performing any Boolean ogic operation.
- instset-heads.cfg
> default file.
- avida
> executable file (compiled for amd64).

#### Additional files required to obtain the data set:
- instructions.txt
> Mapping instruction names in Avida to letters (used by the script *get_database.sh*).
- seed folder
> Files containing the database of 512000 genomes that were randomly-sampled from the genotype space to obtain 1000 organisms encoding the same phenotype (from 0 to 511, in decimal notation) in the same environment for the entire phenotype space (see <a href="https://fortunalab.org/pdf/plos_comp_biol_2017.pdf" target="_blank">our paper in PLoS Comput. Biol.</a>).
- mreps-2.1 folder
> Files required to obtain tandem repeats from transcriptomes (used by the bash script *get_database.sh*).

#### Script that executes Avida and extracts the data:
- get_database.sh.

#### The compressed files that contain the data set (folder *database*) were generated by executing the bash script as follows:

##### execution:
```
./get_database.sh
```
##### output files (only a few zip files are generated: please, replace the corresponding line in the *get_database.sh* file to get the 512 output zip files):
- database_0.zip (145 MB).
- database_1.zip (155 MB).

...

- database_511.zip (165 MB).

---
## 3. Subsetting the working data used in this study (folder *get_File_S1_database*):

### Additional files required to obtain the working data:
- phenotype_id.csv
> Mapping phenotypes to the set of Boolean logic operations (used by the jupyter notebook *get_File_S1_from_database.ipynb* or R script *get_File_S1_from_database.R*).
- get_File_S1_from_database.ipynb
> Jupyter Notebook that populate the folder *get_File_S1_from_database*.
- get_File_S1_from_database.R
>  R script (if you don't want to use Jupyter).

#### The working data set (*File_S1.csv*) that contains the data set used in this study was generated by running the Jupyter Notebook or the R script.

##### output files (only a few zip files are decompressed: please, replace the corresponding line in the *get_File_S1_from_database.ipynb* file (or *get_File_S1_from_database.R*) to get the full working data set):
- full_db.csv
- transcriptomes_id.csv
- File_S1.csv
> The latest file should be the same as the one found in the root folder, but it's not because the current code only generates data for a few organisms (database_0.zip, database_1.zip, and database_511.zip).

---
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.6501535.svg)](https://doi.org/10.5281/zenodo.6501535)
---
